#include "fpp.h"
#include <errno.h>

#if mips
extern int errno;
#endif

#if STDC
void
error(const char *message, int dump_lineno)
#else /* NOT STDC */
void
error(message,dump_lineno)
const char *message;
int dump_lineno;
#endif /* STDC */
{
    int k;

    FPRINTF(stderr,"%s%s%s",ERR_PREFIX,identification(),message);
    if (dump_lineno && (level > 0))
    {
	for (k = 1; k <= level; ++k)
	    FPRINTF(stderr," %d",lineno[k]);
    }
    else if (dump_lineno && (level < 0))
    {
	for (k = 1; k > level; --k)
	    FPRINTF(stderr," %d",lineno[k]);
    }
    FPRINTF(stderr,"\n");
    FPRINTF(stderr,"%sInput line = [%s]\n",ERR_PREFIX,fpp_line);
    if (errno)
    {
	SPRINTF(err_line,"%sperror() says",ERR_PREFIX);
	perror(err_line);
	errno = 0;
    }
    FFLUSH(stderr);
    fpp_code = 1;
}
