#include "fpp.h"

#define NO_MATCH() do {RSTART = -1; RLENGTH = 0; return RSTART;} while (0)

#if STDC
int
match_expr(const char *s)
#else /* NOT STDC */
int
match_expr(s)		/* match #(...), setting RSTART and RLENGTH */
const char *s;		/* RSTART = -1 and RLENGTH = 0 if no match */
#endif /* STDC */
{			/* returned function value is RSTART */
    int plevel;
    const char *sharp;
    const char *p;

    sharp = strchr(s,'#');
    if (sharp == (const char*)NULL)
	NO_MATCH();
    RSTART = sharp - s;
    p = sharp + 1;
    skip_whitespace(p);
    if (*p != '(')
	NO_MATCH();
    plevel = 1;
    ++p;
    RLENGTH = p - sharp;
    while (*p && (plevel != 0))
    {
	if (*p == '(')
	    plevel++;
	else if (*p == ')')
	    plevel--;
	RLENGTH++;
	p++;
    }

    if (plevel != 0)
    {
	SPRINTF(err_line,
	    "Unbalanced parentheses in #(...) expression [%s]",s);
	error(err_line,0);
	NO_MATCH();
    }

#if 1
    if (fpp_debug)
    {
	FPRINTF(stddbg,"match_expr(%s) -> %d %d\n",s,RSTART,RLENGTH);
	FFLUSH(stddbg);
    }
#endif

    return (RSTART);

}
